import errno
import os
# import time
import smtplib
from smtplib import SMTPAuthenticationError
import glob
from pathlib import Path

from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
from email.mime.base import MIMEBase
from email import encoders

import pandas as pd

from dotenv import load_dotenv, find_dotenv
from docx import Document
from docx2pdf import convert

def xls_data_as_dict(review_sheet) -> dict:
    """
        A function to the excel sheet into dictionary data.
        :params review_sheet: An excel sheet that contains
                              all the salary review data
        return dict: contains the data mapped inside a dict
    """

    # Read as dataframe
    df = pd.read_excel(review_sheet)

    # Ensure everything in the dataframe is a string
    df2 = df.astype(str)

    # Turn dataframes into dictionaries
    data = df2.to_dict('records')

    # Format today's date as 'DD MMM YYYY'
    # todaydate = time.strftime("%d %b %Y")

    return {'data': data,}


def fill_template(template, data: dict) -> None:
    """
        Fills template with data from the spredsheet and saves it
        as a docx file in a directory called after the employee's manager

        :params template: docx file containing the template
        :params data: dictionary with the data from the spreadsheet
    """

    # Go over the dictionary without shares
    for person in data['data']:

        # Map variables to columns
        no_shares = Document(template)
        known_as = person['known_as']
        last_name = person['last_name']
        manager = person['reports_to']

        # Strip whitespace from manager name to match directory name
        manager = manager.replace(' ', '')

        # Go over the text in the template
        # and replace variables with data from the dictionary
        for p in no_shares.paragraphs:
            inline = p.runs
            for i in range(len(inline)):
                text = inline[i].text
                for key in person.keys():
                    if key in text:
                        text = text.replace(key, person[key])
                        inline[i].text = text
                for key in data.keys():
                    if key in text:
                        text = text.replace(key, data[key])
                        inline[i].text = text
        # Save template with data
        no_shares.save('./%s/%s_%s.docx' %
                                                              (manager,
                                                              known_as,
                                                              last_name))


def get_manager_data(data: dict) -> dict:
    """
        Gets all managers and their emails
    """
    # Create dictionaries with manager:email as key:value pairs
    managers = {x['reports_to']: x['manager_email'] for x in data['data']}

    return managers


def make_manager_directories(managers: dict) -> None:
    """
        Create a directory for each manager that holds their subordinates'
        letters and strip whitespace from directory name
    """
    try:
        for name in managers.keys():
            os.mkdir(name.replace(' ', ''))
        print('Directories created')
    except OSError as e:
        if e.errno != errno.EEXIST:
            raise


def convert_docs_to_pdf(managers: dict) -> None:
    """
        Converts the docx files generated by fill_template_with_shares
        into pdf documents and removes the original docx file
    """
    # Iterate through each manager in the input dictionary
    for manager in managers:
        # Strip whitespace from manager name to match directory name
        manager_directory = manager.replace(' ', '')
        # Check that the manager directory exists
        if os.path.isdir(manager_directory):
            # Navigate into the manager directory
            os.chdir('./%s' % manager_directory)
            # Get all docx file names
            fileList = glob.glob('*.docx', recursive=True)
            # Iterate through doc files
            for filePath in fileList:
                try:
                    # Convert all docx file into pdf
                    convert(filePath)
                    # Remove docx file after conversion
                    os.remove(filePath)
                except OSError:
                    print("Error while deleting file")
            # Navigate out from the manager directory
            os.chdir('..')


def mail(recipient: str, subject: str, body: str, attach: list) -> None:
    """
        Sends an email with attachments
    """
    # Get credentials
    credentials = get_credentials()
    sender_email = credentials['email']
    pwd = credentials['password']

    # allow either one recipient as string, or multiple as list
    if not isinstance(recipient, list):
        recipient = [recipient]

    # allow either one attachment as string, or multiple as list
    if not isinstance(attach, list):
        attach = [attach]

    msg = MIMEMultipart()
    msg['From'] = sender_email
    msg['To'] = ", ".join(recipient)
    msg['Subject'] = subject
    msg['Reply-To'] = "people@cmrsurgical.com"

    msg.attach(MIMEText(body))

    # get all the attachments
    for file in attach:
        part = MIMEBase('application', 'octet-stream')
        part.set_payload(open(file, 'rb').read())
        encoders.encode_base64(part)
        part.add_header('Content-Disposition', 'attachment; filename="%s"'
                        % os.path.basename(file))
        msg.attach(part)
    try:
        mailServer = smtplib.SMTP("smtp.office365.com", 587)
        mailServer.starttls()
        mailServer.login(sender_email, pwd)
        mailServer.sendmail(sender_email, recipient, msg.as_string())
    except SMTPAuthenticationError:
        raise
    mailServer.close()

def email_dept_heads(managers: dict) -> None:
    """
        Emails all managers the letters they need to send out
    """
    for manager, email in managers.items():
        manager_directory = manager.replace(' ', '')
        try:
            print('Sending email to %s...' % manager)
            os.chdir('./%s' % manager_directory)
            files = glob.glob('*.pdf')
            recipient = email
            subject = 'Annual salary review and bonus letters'
            body = ("Hello,\n\n"
                    "Please find attached letter(s) for your direct report(s) "
                    "confirming the 2023 annual review and 2022 bonus, including performance rating. "
                    "If you have received a letter for an employee who is not your "
                    "direct report, please inform me immediately.\n\n"
                    "Please review and distribute the attached letter(s) directly to "
                    "the individual(s) no later than Wednesday 29 March 2023. If logistically possible, "
                    "please distribute hard copies of these letters in-person to your direct report(s). "
                    "However, if this is not possible, electronic copies via email are acceptable.\n\n"
                    "Please note, some letters for your direct report(s) "
                    "may be sent to you in a separate email directly from me.\n\n"
                    "On Thursday 30 and Friday 31 March, all appraisal reviews will be released to employees "
                    "on Paycor and the annual salary review changes will be reflected in PeopleHR.\n\n"
                    "If you have any questions, notice any errors in the letter(s) or do not receive "
                    "all the letters you are expecting to distribute (either in this email or in subsequent "
                    "separate emails), please contact me directly as soon as possible.\n\n"
                    "Best regards\n"
                    "Steph Callan")
            mail(recipient, subject, body, files)
            os.chdir('..')
            print('Email sent.')
        except ValueError:
            print("Error while sending")


def get_credentials() -> dict:
    """
        Gets credentials to send emails from a specified email address

        :return: dictionary that contains the necessary credentials
    """
    load_dotenv(find_dotenv())
    sender_email = os.getenv("SENDER_EMAIL")
    pwd = os.getenv("PASSWORD")
    return {'email': sender_email, 'password': pwd}


def get_bonuses() -> dict:
    """
        Finds matching docx and excel sheet and fills the template,
        creating a directory for manager

        :return:
    """
    # Create lists of all templates and sheets
    templates = sorted([f for f in glob.glob('*.docx', recursive=True)])
    sheets = sorted([f for f in glob.glob('*.xlsx', recursive=True)])

    # Map template to sheet if they have the same filename
    tsdict = {t: s for (t, s) in zip(templates, sheets)
              if Path(t).stem == Path(s).stem}

    # Create a new dictionary to be used for emailing managers
    managersdict = {}

    try:
        for t, s in tsdict.items():
            review_data = xls_data_as_dict(s)
            managers = get_manager_data(review_data)
            # Add manager to dictionary so they can be emailed
            managersdict.update(managers)
            make_manager_directories(managers)
            fill_template(t, review_data)
            convert_docs_to_pdf(managers)
    except OSError as e:
        if e.errno != errno.EEXIST:
            raise
    return managersdict


if __name__ == '__main__':
    managersdict = get_bonuses()
    email_dept_heads(managersdict)
    # get_email_body('email_body.txt')